/*
 * Created on 6.2.2006
 *
 */
package cz.muni.fi.pb138.demo.dom;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

public class Demo {

    public static Document readAsDOM(File f) {

        // get a DocumentBuilderFactory instance
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();

        // set the options
        //        factory.setValidating(true);
        factory.setNamespaceAware(true);
        try {
            // get a  DocumentBuilder
            DocumentBuilder builder = factory.newDocumentBuilder();

            // parse the file into a new document
            Document document = builder.parse(f);
            return document;

        } catch (SAXException sxe) {
            // Error generated during parsing
            Exception x = sxe;
            if (sxe.getException() != null)
                x = sxe.getException();
            x.printStackTrace();

        } catch (ParserConfigurationException pce) {
            // Parser with specified options can't be built
            pce.printStackTrace();

        } catch (IOException ioe) {
            // I/O error
            ioe.printStackTrace();
        }
        return null;
    }

    public static Document createDocument() {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        Document document = null;
        try {
            DocumentBuilder builder = factory.newDocumentBuilder();
            document = builder.newDocument(); // Create from whole cloth

            Element root = (Element) document.createElement("rootElement");
            document.appendChild(root);
            root.appendChild(document.createTextNode("Some"));
            root.appendChild(document.createTextNode(" "));
            root.appendChild(document.createTextNode("text"));

        } catch (ParserConfigurationException pce) {
            // Parser with specified options can't be built
            pce.printStackTrace();
        }
        return document;
    }
    
    public static void dumpDOM(Document document, OutputStream os) throws TransformerException {
        
        TransformerFactory tf = TransformerFactory.newInstance();
        
        Transformer transformer = tf.newTransformer();
        
        DOMSource ds = new DOMSource(document);
        
        StreamResult sr = new StreamResult(os);
        
        transformer.transform(ds, sr);
    }

    /**
     * @param args
     * @throws TransformerException 
     * @throws FileNotFoundException 
     */
    public static void main(String[] args) throws TransformerException, FileNotFoundException {

        System.out.println("--- create an XML file ---");

        Document document = createDocument();

        System.out.println("--- save it ---");
        dumpDOM(document, new FileOutputStream("demo-dom.xml"));
        
        System.out.println("--- now read the newly created file ---");
        
        Document document2 = readAsDOM(new File("demo-dom.xml"));

        System.out.println("--- print it ---");
        dumpDOM(document2, System.out);
        
    }

}
